
package pi7;

public class Monitor extends Thread {

    private IHM ihm;
    private CommunicationController comm;

    private int JR_ADDRESS = 1;
    
    public void setIHM(IHM ihm) {
        this.ihm = ihm;
    } // setIHM
    
    public void setCommController(CommunicationController comm) {
        this.comm = comm;
    } // setCommController
    
    public void run() {
        while (true) {
          CommReturn ret = null;
          boolean success = true;
          int x = -1, y = -1, line = -1;
          try {
            ret = comm.readRegister(JR_ADDRESS, CommunicationController.Register.X);
            success = success && ret.success;
            if (success)
               x = ret.value;

            ret = comm.readRegister(JR_ADDRESS, CommunicationController.Register.Y);
            success = success && ret.success;
            if (success)
              y = ret.value;

            ret = comm.readRegister(JR_ADDRESS, CommunicationController.Register.PROGRAM_LINE);
            success = success && ret.success;
            if (success)
              line = ret.value;

            if (success) {
              ihm.exibirPosicaoCorrente(x, y);
              ihm.exibirLinhaCorrente(line);
            }
            try { sleep(1000); } catch(Exception e) {}

          } catch(Exception e) {
              e.printStackTrace();
          }
          
        } // while true
    } // run
} 